define([
            'jquery',
            'underscore',
            './ManyShapeSeries',
            '../util/lang_utils'
        ],
        function(
            $,
            _,
            ManyShapeSeries,
            langUtils
        ) {

    var BarSeries = function(properties) {
        ManyShapeSeries.call(this, properties);
    };
    langUtils.inherit(BarSeries, ManyShapeSeries);

    $.extend(BarSeries.prototype, {

        CHARTING_PROPERTY_WHITELIST: _.union(['barSpacing'], ManyShapeSeries.prototype.CHARTING_PROPERTY_WHITELIST),

        type: 'bar',

        getConfig: function() {
            var config = ManyShapeSeries.prototype.getConfig.call(this);
            config.pointPadding = this.computeBarSpacing(this.properties['barSpacing']);
            config.groupPadding = this.computeBarGroupSpacing(this.properties['seriesSpacing']);
            return config;
        },

        // SPL-68694, this should be a no-op for bar series or it will interfere with click handlers
        bringToFront: function() { }

    });

    return BarSeries;

});