define(
    [
        'underscore',
        'models/SplunkDBase'
    ],
    function(_, SplunkDBaseModel) {
        return SplunkDBaseModel.extend({
            url: "data/vix-providers/",
            urlRoot: "data/vix-providers/",
            initialize: function() {
                SplunkDBaseModel.prototype.initialize.apply(this, arguments);
                this.blacklistedAttrs = [];
            },
            disableAttr: function(attr) {
                this.blacklistedAttrs.push(attr);
            },
            enableAttr: function(attr) {
                this.blacklistedAttrs.splice(_(this.blacklistedAttrs).indexOf(attr),1);
            },
            save: function (attrs, options) {
                attrs = attrs || this.entry.content.toJSON();
                options = options || {};
                // If model defines blacklistedAttrs, replace attrs with trimmed version
                if (this.blacklistedAttrs) {
                    attrs = _(attrs).omit(this.blacklistedAttrs);
                }
                options.attrs = attrs;
                // Call super with attrs moved to options
                return SplunkDBaseModel.prototype.save.call(this, attrs, options);
            }
        });
    }
);