define([
            'underscore',
            'models/SplunkDRaw',
            'models/shared/fetchdata/ResultsFetchData',
            'util/splunkd_utils'
        ],
        function(
            _,
            SplunkDRaw,
            ResultsFetchData,
            splunkdUtils
        ) {

    return SplunkDRaw.extend({

        initialize: function(attributes, options) {
            options = options || {};
            if (_(options.fetchData).isUndefined())
                options.fetchData = new ResultsFetchData({ output_mode: 'json_rows' });
            SplunkDRaw.prototype.initialize.call(this, attributes, options);
        },

        parse: function(response) {
            return _(response).pick('fields', 'rows', 'post_process_count');
        }

    });

});