//splunk cmd node $SPLUNK_HOME/lib/node_modules/requirejs/bin/r.js -o jscharting.js
({
    baseUrl: '../',
    preserveLicenseComments: false,
    name: 'contrib/almond',
    stubModules: [],
    optimize: 'uglify',
    include: 'js_charting/js_charting',
    wrap: {
        start: ' ',
        end: 'require("splunk").JSCharting = require("js_charting/js_charting");'
    },
    out: '../build/jscharting.js',
    paths: {

        // jQuery and contrib plugins
        'jquery': 'stubs/jquery',

        // other contrib libraries
        'underscore': 'contrib/underscore',
        'highcharts': 'contrib/highcharts-3.0.7/highcharts',
        'highcharts.runtime_patches': 'contrib/highcharts-3.0.7/runtime_patches',
        'moment': 'contrib/moment',

        // Splunk legacy
        'splunk': 'stubs/splunk',
        'splunk.util': 'stubs/splunk.util',
        'splunk.i18n': 'stubs/i18n',
        'splunk.config': 'stubs/splunk.config',
        'splunk.logger': 'stubs/splunk.logger',
        'strftime': 'stubs/strftime'

    },
    shim: {

        /* START other contrib libraries */
        underscore: {
            deps: ['splunk.i18n'],
            exports: '_',
            init: function(i18n) {
                // use underscore's mixin functionality to add the ability to localize a string
                this._.mixin({
                    t: function(string) {
                        return i18n._(string);
                    }
                });
                return this._.noConflict();
            }
        },
        highcharts: {
            deps: ['jquery', 'highcharts.runtime_patches'],
            exports: 'Highcharts',
            init: function($, runtimePatches) {
                runtimePatches.applyPatches(this.Highcharts);
                return this.Highcharts;
            }
        }
    }
})
