define(
    [
        'jquery',
        'underscore',
        'routers/Base',
        'models/services/data/vix/Index',
        'models/classicurl',
        'collections/services/data/vix/Providers',
        'views/virtual_indexes/config/IndexSetup'
    ],
    function(
        $,
        _,
        BaseRouter,
        IndexModel,
        ClassicurlModel,
        ProvidersCollection,
        IndexSetupView
        ) {
        return BaseRouter.extend({
            initialize: function() {
                BaseRouter.prototype.initialize.apply(this, arguments);
                this.enableAppBar = false;
                this.indexModel = new IndexModel();
                this.providersCollection = new ProvidersCollection();
                this.providersCollection.fetch();
                this.indexSetup = new IndexSetupView({
                    model: {
                        index: this.indexModel,
                        application: this.model.application
                    },
                    collection: {
                        providers: this.providersCollection
                    }
                });
            },
            page: function(locale, app, page) {
                BaseRouter.prototype.page.apply(this, arguments);
                this.deferreds.pageViewRendered.done(function() {
                    $('.preload').replaceWith(this.pageView.el);
                }.bind(this));

                ClassicurlModel.fetch({
                    success: function(model, response) {
                        var id = ClassicurlModel.get('id');
                        if (id) {
                            this.indexModel.id = id;
                            this.indexModel.set({'mode':'edit'}, {silent: true});
                            this.indexModel.fetch();
                            this.setPageTitle(_('Edit virtual index').t());
                        } else {
                            this.indexModel.set({'mode':'new'}, {silent: true});
                            this.setPageTitle(_('New virtual index').t());
                        }
                        this.deferreds.pageViewRendered.done(function() {
                            this.pageView.$('.main-section-body').append(this.indexSetup.render().el);
                        }.bind(this));
                    }.bind(this)
                });

            }
        });
    }
);