define(function(require, module){
    var _ = require('underscore'),
        $ = require('jquery'),
        BaseView = require('views/Base'),
        Dashboard = require('../simplexml/controller');

    return BaseView.extend({
        moduleId: module.id,
        className: 'fieldset',
        initialize: function() {
            this.listenTo(Dashboard, 'formupdate', this.render);
            this.listenTo(Dashboard.model, 'change:edit change:rootNodeName', this.render);
            BaseView.prototype.initialize.apply(this, arguments);
        },
        isEmpty: function(){
            return !$.trim(this.$el.html());
        },
        render: function() {
            if(Dashboard.isEditMode() || !_.all(this.$el.find('.input>label'), function(label) {
                return !$.trim($(label).text());
            })) {
                this.$el.removeClass('hide-label');
            } else {
                this.$el.addClass('hide-label');
            }
            var rootNodeName = Dashboard.model.get('rootNodeName');
            if (rootNodeName != null && rootNodeName !== 'form') {
                this.$el.hide();
            } else {
                this.$el.show();
            }
            return this;
        }
    });
});