define(
    [
        'underscore',
        'module',
        'views/Base'
    ],
    function(
        _,
        module,
        BaseView
    )
    {
        return BaseView.extend({
            moduleId: module.id,
            initialize: function() {
                BaseView.prototype.initialize.apply(this, arguments);
            },
            render: function() {
                this.$el.html(this.compiledTemplate({
                    _: _
                }));
                return this;
            },
            template: '\
                <h2 class="section-title"><i class="icon-bell"></i> <%- _("Alerts").t() %></h2>\
                <p class="section-description">\
                    <%- _("Alerts set a condition that when met trigger an action, such as sending an email that contains the results of the triggering search to a list of people. Click the name to view the alert. Open the alert in Search to refine the parameters.").t() %>\
                </p>\
            '
        });
    }
);
