define(
    [
        'module',
        'views/Base',
        'views/reports/Title',
        'views/reports/table/Master'
    ],
    function(
        module,
        BaseView,
        TitleView,
        TableView
    ){
        return BaseView.extend({
            moduleId: module.id,
            /**
             * @param {Object} options {
             *     model: {
             *         state: <models.Base>,
             *         application: <models.Application>,
             *         appLocal: <models.services.AppLocal>
             *         user: <models.service.admin.user>,
             *         uiPrefs: <models.services.admin.UIPrefs>
             *     },
             *     collection: {
             *         reports: <collections.Reports>
             *         roles: <collections.services.authorization.Roles>
             *     }
             * }
             */
            initialize: function() {
                BaseView.prototype.initialize.apply(this, arguments);

                this.children.title = new TitleView();
                this.children.table = new TableView({
                    model: {
                        state: this.model.state,
                        application: this.model.application,
                        user: this.model.user,
                        appLocal: this.model.appLocal,
                        uiPrefs: this.model.uiPrefs
                    },
                    collection: {
                        roles: this.collection.roles,
                        reports: this.collection.reports
                    }
                });
            },
            render: function() {
                this.$el.html(this.template);
                this.children.title.render().appendTo(this.$('.section-header'));
                this.children.table.render().appendTo(this.$el);
                return this;
            },
            template: '<div class="section-padded section-header"></div><div class="divider"></div>'
        });
    }
);
