define(['underscore', 'module', 'views/Base'], function(_, module, Base) {
    return Base.extend({
        tagName: 'li',
        moduleId: module.id,
        initialize: function() {
            Base.prototype.initialize.apply(this, arguments);
        },
        startListening: function() {
            this.listenTo(this.model.report.entry.content, 'change:display.general.type', this.toggleActive);
        },
        activate: function(options) {
            if (this.active) {
                return Base.prototype.activate.apply(this, arguments);
            }
            this.toggleActive();
            return Base.prototype.activate.apply(this, arguments);
        },
        events: {
            'click a': function(e){
                this.model.report.entry.content.set('display.general.type', $(e.currentTarget).attr('data-type'));
                e.preventDefault();
            }
        },
        toggleActive: function() {
            (this.model.report.entry.content.get('display.general.type') == 'visualizations') ?
                this.$el.addClass('active') :
                this.$el.removeClass('active');
        },
        render: function() {
            this.$el.html(this.compiledTemplate({
                _: _
            }));
            this.toggleActive();
            return this;
        },
        template:'\
            <a href="#" data-type="visualizations">\
                <%- _("Visualization").t() %>\
            </a>\
        '
    });
});
