define(
    [
        'underscore',
        'module',
        'views/Base',
        'uri/route'
    ],
    function(_, module, Base, route) {
        return Base.extend({
            moduleId: module.id,
            className:'panel-row',
            initialize: function() {
                Base.prototype.initialize.apply(this, arguments);
            },
            events: {
                'click .view-fields': function(e) {
                    this.model.report.entry.content.set('display.general.type', 'events');
                    e.preventDefault();
                },
                'click ul.unstyled li a': function(e) {
                    e.preventDefault();
                }
            },
            render: function() {
                if (!this.el.innerHTML) {
                    var root = this.model.application.get("root"),
                        locale = this.model.application.get("locale"),
                        app = this.model.application.get("app"),
                        version = this.model.appLocal.entry.content.get('version'),
                        appAllowsDisable = this.model.appLocal.appAllowsDisable();
                  this.$el.html(this.compiledTemplate({
                    _: _,
                    chartDocRoute: route.docHelp(root, locale, 'search_app.assist.chart'),
                    contigencyDocRoute: route.docHelp(root, locale, 'search_app.assist.contigency'),
                    statsDocRoute: route.docHelp(root, locale, 'search_app.assist.stats'),
                    timechartDocRoute: route.docHelp(root, locale, 'search_app.assist.timechart'),
                    topDocRoute: route.docHelp(root, locale, 'search_app.assist.top'),
                    moreDocRoute: route.docHelp(root, locale, 'learnmore.search.transforming')
                  }));
                }
                return this;
            },
            template: '\
                    <div class="alert alert-info">\
                        <i class="icon-alert"></i>\
                        <%- _("Your search isn\'t generating any statistic or visualization results. Here are some possible ways to get results.").t() %>\
                    </div>\
                    <div class="row">\
                        <div class="help-quick-reports">\
                            <h3><%- _("Quick Reports").t() %></h3>\
                            <p>\
                              <%- _("In the field summaries you can choose to create a simple report like \'Top Referrers\' and \'Top Referrers by time\'. Field summaries are available in the left bar of the").t() %> <a href="#" class="view-fields"><%- _("events tab").t() %></a> <%- _("and and beside each event\'s field values.").t() %>\
                           </p>\
                             <div class="screenshot no-stats-fields"></div>\
                        </div>\
                        <div class="help-stats-commands">\
                            <h3><%- _("Search Commands").t() %></h3>\
                            <p><%- _("You can use many search commands to summarize your event data, such as these:").t() %></p>\
                            <div class="commands">\
                                <p><a href="<%- chartDocRoute %>" target="_blank" title="<%- _("Splunk help").t() %>" ><%- _("chart").t() %> <i class="icon-external"></i></a><br \ ><%- _("Create a statistics table compatible with most types of visualizations.").t() %></p>\
                                <p><a href="<%- contigencyDocRoute %>" target="_blank" title="<%- _("Splunk help").t() %>" ><%- _("contingency").t() %> <i class="icon-external"></i></a><br /><%- _("Create a contingency table to record and analyze the relationship between two or more (usually categorical) variables.").t() %></p>\
                                <p><a href="<%- statsDocRoute %>" target="_blank" title="<%- _("Splunk help").t() %>" ><%- _("stats").t() %> <i class="icon-external"></i></a><br/><%- _("Provides statistics optionally grouped by field.").t() %></p>\
                                <p><a href="<%- timechartDocRoute %>" target="_blank" title="<%- _("Splunk help").t() %>" ><%- _("timechart").t() %> <i class="icon-external"></i></a><br/><%- _("Creates a time series chart with corresponding table of statistics.").t() %></p>\
                                <p><a href="<%- topDocRoute %>" target="_blank" title="<%- _("Splunk help").t() %>" ><%- _("top").t() %> <i class="icon-external"></i></a><br/><%- _("Displays the most common values of a field.").t() %></p>\
                            </div>\
                            <a href="<%- moreDocRoute %>" target="_blank" title="<%- _("Splunk help").t() %>" class="btn-documentation"><%- _("More").t() %> <i class="icon-external"></i></a>\
                        </div>\
                    </div>\
            '
        });
    }
);
