define(['underscore', 'module', 'views/Base', 'bootstrap.tooltip'], function(_, module, BaseView /* bootstrap tooltip */) {
    return BaseView.extend({
        moduleId: module.id,
        className: 'reload btn-pill btn-square',
        tagName: 'a',
        attributes: {
            "href": "#"
        },
        initialize: function() {
            BaseView.prototype.initialize.apply(this, arguments);
            this.$el.tooltip({animation:false, title:_('Reload').t(), container: 'body'});
        },
        events: {
            "click": function(e) {
                e.preventDefault();
                // just trigger a custom event on the job model and let upstream logic handle it
                
                if (!this.isActive()) {
                	return true;
                }
                
                this.model.trigger('reload');
            }
        },
        isActive: function() {
            // active only when the job is complete
            return this.model.entry.content.get('isDone');
        },
        render: function() {
            this.$el.html('<i class="icon-rotate-counter"></i><span class="hide-text">' + _('Reload').t() + '</span>');
            return this;
        },
        remove: function() {
            this.$el.tooltip('destroy');
            return BaseView.prototype.remove.apply(this, arguments);
        }
    });
});
