define(
    [
         'module',
         'models/Base',
         'models/search/Dashboard',
         'views/shared/Modal',
         'views/shared/reportcontrols/dialogs/dashboardpanel/Create',
         'views/shared/reportcontrols/dialogs/dashboardpanel/Success'
     ],
     function(module, BaseModel, DashboardModel, Modal, Create, Success){
        return Modal.extend({
            moduleId: module.id,
            initialize: function() {
                Modal.prototype.initialize.apply(this, arguments);
                var chooseVisualizationType = this.options.hasOwnProperty('chooseVisualizationType') ?
                        this.options.chooseVisualizationType : true;

                this.model.dashboardToSave = new DashboardModel({}, {indent: true});
                this.model.inmem = new BaseModel({
                    dashPerm: "private",
                    panelContent: "table",
                    dashCreateType: "new",
                    panelInline: true
                });

                this.children.create = new Create({
                    model: {
                        report: this.model.report,
                        application: this.model.application,
                        searchJob: this.model.searchJob,
                        dashboardToSave: this.model.dashboardToSave,
                        inmem: this.model.inmem
                    },
                    chooseVisualizationType: chooseVisualizationType
                });

                this.children.success = new Success({
                    model: {
                        dashboardToSave: this.model.dashboardToSave,
                        inmem: this.model.inmem,
                        application: this.model.application
                    }
                });

                this.model.inmem.on('createSuccess', function(){
                    this.children.create.$el.hide();
                    this.children.success.$el.show();
                },this);
            },
            render: function() {
                this.children.create.render().appendTo(this.$el);
                this.children.success.render().appendTo(this.$el);
                this.children.success.$el.hide();
                return this;
            }
        });
    }
);