/**
 * @author jszeto
 * @date 11/4/13
 *
 * ResultTableMaster subclass that adds special logic for showing a checkmark or x in the left column
 */
define([
    'jquery',
    'underscore',
    'backbone',
    'module',
    './ResultsTableMaster',
    './MatchResultsTableHeader',
    './renderers/CheckmarkCellRenderer'
],
    function (
        $,
        _,
        Backbone,
        module,
        ResultsTableMaster,
        MatchResultsTableHeader,
        CheckmarkCellRenderer) {
        
        return ResultsTableMaster.extend({
            moduleId:module.id,

            initialize:function (options) {
                this.options = $.extend(true, {headerClass: MatchResultsTableHeader}, this.options);

                ResultsTableMaster.prototype.initialize.call(this, this.options);
                this.addCellRenderer(new CheckmarkCellRenderer());
            }
        });

    });

