define(
    [
        'jquery',
        'underscore',
        'backbone',
        'module',
        'views/Base'
    ],
    function($, _, Backbone, module, BaseView) {
        return BaseView.extend({
            moduleId: module.id,
            initialize: function() {
                BaseView.prototype.initialize.apply(this, arguments);
            },
            events: {
                'click .btn': function(e) {
                    this.model.trigger('applied');
                    e.preventDefault();
                }
            },
            render: function() {
                if (this.$el.html()) {
                    return this;
                }
                
                var template = _.template(this.template, {});
                this.$el.html(template);

                return this;
            },
            template: '\
                <a class="btn" href="#"><i class="icon-search-thin"></i></a>\
            '
        });
    }
);
